import axios from 'axios';
import { API_URL_HOME } from '@/shared/api/api-url-home';
import { resultify } from '@/shared/lib/resultify';
import { NiceAxiosError } from '@/shared/@types/error';
import { 
  HomeMonthParams,
  HomeMonthResponse
} from '../model/types';
import { 
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';
import { getHeaderUserAgent } from '@/shared/constants/url';

export const homeMonth = (params: HomeMonthParams) => {
  let headerOptions = {
    menuId: 0,
    apiType: 'SELECT'
  };
  let options = {
    headers: {
      'X-User-Agent': getHeaderUserAgent(headerOptions)
    }
  };
  return resultify(
    axios.post<HomeMonthResponse>(API_URL_HOME.homeMonth(), params, options),
  );
};

export const useHomeMonthwMutation = (options?: UseMutationOptions<HomeMonthResponse, NiceAxiosError, HomeMonthParams>) => {
  const mutation = useMutation<HomeMonthResponse, NiceAxiosError, HomeMonthParams>({
    ...options,
    mutationFn: (params: HomeMonthParams) => homeMonth(params),
  });

  return {
    ...mutation,
  };
};
